/* event.h -- event headers */

#ifndef EVENT_H
#define EVENT_H

/* includes */
#define _GNU_SOURCE
#include <stdio.h>
#include <sys/select.h>
#include <unistd.h>

/* defines */

/* return values */
#define CALLBACK_ERROR -1
#define E_ERROR -1
#define E_SUCCESS 1
#define E_FD_YES 2
#define E_FD_NO 3

/* event status */
#define DISABLED 0
#define ENABLED 1

/* read write mode */
#define READ 'r'
#define WRITE 'w'
/* add remove mode */
#define ADD 'a'
#define REMOVE 'r'

/* immediatley values */
#define IMM_FALSE 0
#define IMM_TRUE 1

/* event specific variables */
typedef struct s_event {
  int outfd;
  int maxfd;
  fd_set rfds,rfds_o;
  fd_set wfds,wfds_o;
  struct timeval timeout;
  unsigned char immediately;
  unsigned char status;
} t_event;

/* function prototypes */
int event_init(t_event *event,int outfd);
int event_set_timeout(t_event *event,int sec,int usec);
int event_set_immediately(t_event *event,unsigned char value);
int event_math(int fd,t_event *event,char rw,char ar);
int event_start(t_event *event,void *ptr,
                int (*callback0)(t_event *event,void *ptr),
                int (*callback1)(t_event *event,void *ptr));
int event_check(t_event *event,int fd);
int event_stop(t_event *event);

#endif
